Attribute VB_Name = "Module1"
'Declarations for Ports
Declare Sub OutPort Lib "gvc009.dll" (ByVal Port As Integer, ByVal Dat As Integer)
Declare Function InPort Lib "gvc009.dll" (ByVal Port As Integer) As Integer
'Declare Sub Sleep Lib "gvc010.dll" (ByVal Wait As Integer)

'Declarations for Configuration ...
Public CFG$(255)
Public CFGEnd As Integer
Public Const CFGFile$ = "ect_win.cfg"
Public Const CFGEndMax = 27
Public CDIR$

Global Const MaxWidth = 8175
Global Const MaxHeight = 6225

Global NPoints '0 - if there is no graphic
               'number of points - if "Get Points"
               
Global gv(1024) As Double, gi(1024) As Double
Global gv1(1024) As Double, gi1(1024) As Double

Global di As Double, dv As Double
Global yyc As Long, xxc As Long

Global Dres As Double

Global IPORTA As Integer
Global IPORTB As Integer
Global IPORTC As Integer

Global ITim As Integer 'For Module GetPoints

Global DDel As Double
'****************************************************************************
'Loading configuration
Public Sub LoadCFG()
    Dim i As Integer
    
    On Error Resume Next
 
    Err = 0
    FIL = FreeFile

    Open CDIR$ + CFGFile$ For Input As #FIL
    If Err <> 0 Then
        Call StdCFG(0)
        Exit Sub
    End If
  
    i = 0
    Err = 0
    While EOF(FIL) <> -1
        If Err <> 0 Then
            Call StdCFG(0)
            Exit Sub
        End If
        
        Line Input #FIL, CFG$(i)
        i = i + 1
    Wend

    Close #FIL
    CFGEnd = i - 1
  
    If CFGEnd <> CFGEndMax Then
        Call StdCFG(0)
        Exit Sub
    End If
End Sub
'****************************************************************************
'Default configuration
Public Sub StdCFG(Param As Integer)
    If Param = 0 Or Param = 1 Then
        CFG$(0) = "0"             'X position for window
        CFG$(1) = "0"             'Y position for window
        CFG$(2) = Str$(MaxWidth)  'Width of window
        CFG$(3) = Str$(MaxHeight) 'Height of window
        CFG$(4) = "0"             'State of Window
        CFG$(5) = "1"             'Save position and dimensions on exit?
        CFG$(6) = "1"             'Show About while loading
        CFG$(7) = ""              'Reserved
        CFG$(8) = ""              'Reserved
        CFG$(9) = ""              'Reserved
    End If

    If Param = 0 Or Param = 2 Then
        CFG$(10) = "100"   'Delay in micros. (output to port)
        CFG$(11) = "0"   'R \
        CFG$(12) = "96"  'G  -> Background Color
        CFG$(13) = "0"   'B /
        CFG$(14) = "0"   'R \
        CFG$(15) = "255" 'G  -> Color of line in plot
        CFG$(16) = "0"   'B /
        CFG$(17) = "0"   'Smoothing
        CFG$(18) = "5"   'Param of smoothing
        CFG$(19) = "5"   'V
        CFG$(20) = "10"  'mA
        CFG$(21) = "3"   'Numb of points
        CFG$(22) = "0"   'R \
        CFG$(23) = "180" 'G  -> Color of symbols in plot
        CFG$(24) = "0"   'B /
        CFG$(25) = "378" 'Address of Port with device
        CFG$(26) = "4"   'Averaging on number of points
    End If
    
    CFGEnd = CFGEndMax
End Sub
'****************************************************************************
'Checking configuration
Public Sub CheckCFG(Param As Integer)
    Dim X As Integer
    
    If Param = 0 Or Param = 1 Then
        If Val(CFG$(0)) > Screen.Width - 1000 Then
            CFG$(0) = Str$(Screen.Width - 1000)
        End If
    
        If Val(CFG$(1)) > Screen.Height - 1000 Then
            CFG$(1) = Str$(Screen.Height - 1000)
        End If
        
        If Val(CFG$(2)) < MaxWidth Then
            CFG$(2) = Str$(MaxWidth)
        End If
    
        If Val(CFG$(3)) < MaxHeight Then
            CFG$(3) = Str$(MaxHeight)
        End If
    End If

    If Param = 0 Or Param = 2 Then
        If Val(CFG$(10)) < 1 Then CFG$(10) = "1"
        
        X = Val(CFG$(11))
        If X < 0 Or X > 255 Then CFG$(11) = "128"
    
        X = Val(CFG$(12))
        If X < 0 Or X > 255 Then CFG$(12) = "128"
    
        X = Val(CFG$(13))
        If X < 0 Or X > 255 Then CFG$(13) = "128"

        X = Val(CFG$(14))
        If X < 0 Or X > 255 Then CFG$(14) = "128"
        
        X = Val(CFG$(15))
        If X < 0 Or X > 255 Then CFG$(15) = "128"
        
        X = Val(CFG$(16))
        If X < 0 Or X > 255 Then CFG$(16) = "128"
    
        X = Val(CFG$(17))
        If X <> 0 And X <> 1 Then CFG$(17) = "0"
        
        X = Val(CFG$(18))
        If X < 3 Or X > 30 Then CFG$(18) = "5"
        
        X = Val(CFG$(19))
        If X < 1 Or X > 5 Then CFG$(19) = "5"
      
        X = Val(CFG$(20))
        If X < 1 Or X > 10 Then CFG$(20) = "5"

        X = Val(CFG$(21))
        If X < 1 Or X > 6 Then CFG$(21) = "3"
        
        X = Val(CFG$(22))
        If X < 0 Or X > 255 Then CFG$(22) = "128"
    
        X = Val(CFG$(23))
        If X < 0 Or X > 255 Then CFG$(23) = "128"

        X = Val(CFG$(24))
        If X < 0 Or X > 255 Then CFG$(24) = "128"
    
        X = Val("&H" + CFG$(25))
        If X < 0 Or X > 16384 Then CFG$(25) = "378"
    
        X = Val(CFG$(26))
        If X < 1 Or X > 100 Then CFG$(26) = "4"
    End If
End Sub
'****************************************************************************
'Saving configuration
Public Sub SaveCFG()
    Dim i As Integer
 
    On Error Resume Next
 
    FIL = FreeFile
    Open CDIR$ + CFGFile$ For Output As #FIL
        
    For i = 0 To CFGEnd
        Print #FIL, CFG$(i)
    Next i

    Close #FIL
End Sub
'****************************************************************************
Public Sub RedrawPlot()
    Dim x1 As Integer, y1 As Integer
    Dim x2 As Integer, y2 As Integer
    Dim xc As Integer, yc As Integer
    Dim xl As Integer, yl As Integer

    Dim qi As Double, qv As Double
    Dim yi As Integer, xv As Integer
    Dim si As Double, sv As Double

    Dim Istep As Integer
    Dim iwork As Integer

    Dim dx As Double, dy As Double
    Dim jx As Integer, jy As Integer
    Dim jx1 As Integer, jy1 As Integer

    Dim i As Integer

    'Declarations for polynoms
    Dim IDeg As Integer, ke As Integer
    Dim cf_x As Double, cf_xy As Double, cf_y As Double
    Dim cf_x2 As Double
    Dim cf_d As Double, cf_b As Double, cf_a As Double
                                                   
    'Making picture
    Col1 = RGB(Val(CFG$(11)), Val(CFG$(12)), Val(CFG$(13)))
    Col2 = RGB(Val(CFG$(14)), Val(CFG$(15)), Val(CFG$(16)))
    Col3 = RGB(Val(CFG$(22)), Val(CFG$(23)), Val(CFG$(24)))
 
    'Background
    MainForm.Picture1.BackColor = Col1
    MainForm.Picture1.ForeColor = Col3
    
    'Size
    x1 = 20: y1 = 10
    x2 = MainForm.Picture1.ScaleWidth - x1 - 5
    y2 = MainForm.Picture1.ScaleHeight - y1 - 10

    xl = x2 - x1 + 1: yl = y2 - y1 + 1

    xc = x1 + (x2 - x1) / 2: yc = y1 + (y2 - y1) / 2
    xxc = xc: yyc = yc 'Global

    GoSub RedrawPlot1

    If NPoints = 0 Then Exit Sub
 
    'Drawing plot from array!
 
    Istep = 1024 / NPoints
 
    '------------------ Polynom ------------------------
    If MainForm.Check1.Value = 1 Then
        IDeg = MainForm.HScroll1.Value
        ReDim gvq(1024) As Double, giq(1024) As Double, gip(1024) As Double
  
        ke = 0
        For i = 0 To 1023 Step Istep
            ke = ke + 1
            gvq(ke) = gv(i)
            giq(ke) = gi(i) * 1000 'converting to mA
        Next i
  
        For i = 1 To ke - IDeg + 1 Step IDeg
            cf_x = 0: cf_xy = 0: cf_y = 0: cf_x2 = 0
            For j = i To i + IDeg - 1
                cf_x = cf_x + gvq(j)
                cf_xy = cf_xy + gvq(j) * giq(j)
                cf_y = cf_y + giq(j)
                cf_x2 = cf_x2 + (gvq(j) ^ 2)
            Next j
            cf_x = cf_x / IDeg: cf_xy = cf_xy / IDeg
            cf_y = cf_y / IDeg: cf_x2 = cf_x2 / IDeg
            cf_d = cf_x2 - ((cf_x) ^ 2)
            If cf_d = 0 Then cf_b = 10000# Else cf_b = (cf_xy - (cf_x * cf_y)) / cf_d
            cf_a = cf_y - (cf_b * cf_x)
   
            For j = i To i + IDeg - 1
                giq(j) = cf_a + (cf_b * gvq(j))
            Next j
        Next i
 
        ke = 0
        For i = 0 To 1023 Step Istep
            ke = ke + 1
            gip(i) = giq(ke)
        Next i
  
    End If

    '------------------ Plot -----------------
    MainForm.Picture1.DrawWidth = 2
    iwork = 0
    For i = 0 To 1023 Step Istep
        dx = gv(i)
        dy = gi(i) * 1000 'Converting to mA
        If MainForm.Check1.Value = 1 Then dy = gip(i)
        jx = xc + CInt(dx * dv + 0.001)
        jy = yc - CInt(dy * di + 0.001)
   
        If (dx < -vmax Or dx > vmax) Or (dy < -imax Or dy > imax) Then
            iwork = 0
        Else
            If iwork = 0 Then jx1 = jx: jy1 = jy: iwork = 1
            MainForm.Picture1.Line (jx, jy)-(jx1, jy1), Col2
        End If
        jx1 = jx: jy1 = jy
    Next i
    MainForm.Picture1.DrawWidth = 1
 
    'Redraw lines one more time
    GoSub RedrawPlot1
    
    Exit Sub

    'Redraw lines
RedrawPlot1:
    MainForm.Picture1.Line (x1, yc)-(x2 + 5, yc), Col3
    MainForm.Picture1.Line (xc, y1 - 5)-(xc, y2), Col3
  
    MainForm.Picture1.Line (xc, y1 - 5)-(xc - 5, y1), Col3
    MainForm.Picture1.Line (xc, y1 - 5)-(xc + 5, y1), Col3

    MainForm.Picture1.Line (x2 + 5, yc)-(x2, yc - 5), Col3
    MainForm.Picture1.Line (x2 + 5, yc)-(x2, yc + 5), Col3

    MainForm.Picture1.CurrentX = xc + 10
    MainForm.Picture1.CurrentY = y1 - 6
    MainForm.Picture1.Print "I, mA"

    MainForm.Picture1.CurrentX = x2 - 37
    MainForm.Picture1.CurrentY = yc - 20
    MainForm.Picture1.Print "V, Volts"

    vmax = MainForm.HScroll2.Value
    imax = MainForm.HScroll3.Value

    dv = xl / (2 * vmax): di = yl / (2 * imax)

    sv = vmax / 5: si = imax / 5

    For qv = -vmax To vmax + 0.001 Step sv
        xv = xc + CInt(qv * dv + 0.001)
        MainForm.Picture1.Line (xv, yc - 3)-(xv, yc + 3), Col3
        If qv > 0 Then
            MainForm.Picture1.CurrentY = yc + 4
        Else
            MainForm.Picture1.CurrentY = yc - 16
        End If
        MainForm.Picture1.CurrentX = xv - 12
        If qv < -0.001 Or qv > 0.001 Then
            A$ = "0.0": If qv > 0 Then A$ = " 0.0"
            MainForm.Picture1.Print Format$(qv, A$)
        End If
    Next qv

    For qi = -imax To imax + 0.001 Step si
        yi = yc - CInt(qi * di + 0.001)
        MainForm.Picture1.Line (xc - 3, yi)-(xc + 3, yi), Col3
        If qi > 0 Then
            MainForm.Picture1.CurrentX = xc - 30
        Else
            MainForm.Picture1.CurrentX = xc + 4
        End If
        MainForm.Picture1.CurrentY = yi - 6
        If qi < -0.001 Or qi > 0.001 Then
            A$ = "#0.0": If qi > 0 Then A$ = " #0.0"
            MainForm.Picture1.Print Format$(qi, A$)
        End If
    Next qi

    For qi = -imax To imax + 0.001 Step si
        For qv = -vmax To vmax + 0.001 Step sv
            xv = xc + CInt(qv * dv + 0.001)
            yi = yc - CInt(qi * di + 0.001)
            MainForm.Picture1.PSet (xv, yi), Col3
        Next qv
    Next qi

    Return

End Sub
'****************************************************************************
Sub PutSwitch(i)
    Dim da As Double
    Dim ir1 As Integer, ir2 As Integer
    Dim iyc As Integer
    Dim ia As Integer, ib As Integer, ic As Integer
    Dim irx As Integer
    Dim icol As Long
    Dim dx1 As Double, dx2 As Double
    Dim da1 As Double, da2 As Double
    Dim da3 As Double, da4 As Double

    Static ix0, ix1, ix2, ix3, ix4
    Static iy0, iy1, iy2, iy3, iy4

    Const dpi = 3.14159

    Select Case i
        Case 0:   da = 40
        Case 1:   da = 80
        Case 2:   da = 120
        Case Else: Dr = 40
    End Select

    da = da * dpi / 180

    iyc = 25

    ir1 = 7
    ir2 = 16

    ia = 40: ib = 30

    If ix0 + ix1 + ix2 + ix3 + ix4 <> 0 Then
        icol = MainForm.Picture2.BackColor: GoSub PUT_SW_1
    End If

    ix0 = 100
    iy0 = 50

    ix1 = ix0 - ia * Sin(da)
    iy1 = iy0 + ia * Cos(da)

    irx = (ia + ib) * ir1 / ia
    ic = Sqr((irx ^ 2) + ((ia + ib) ^ 2))

    dx1 = ir1 / ia: dx2 = Sqr(1 - (dx1 ^ 2))
    If dx1 <> 0 Then da2 = Atn(dx1 / dx2) Else da2 = dpi / 2

    da1 = dpi / 2 - da: da3 = da1 + da2: da4 = da1 - da2

    ix3 = ix1 + ic * Cos(da3)
    iy3 = iy1 - ic * Sin(da3)
    ix4 = ix1 + ic * Cos(da4)
    iy4 = iy1 - ic * Sin(da4)

    MainForm.Picture2.CurrentX = 12
    MainForm.Picture2.CurrentY = 80
    MainForm.Picture2.Print "0.1 kOm";

    MainForm.Picture2.CurrentX = 12
    MainForm.Picture2.CurrentY = 50
    MainForm.Picture2.Print "1.0 kOm";

    MainForm.Picture2.CurrentX = 7
    MainForm.Picture2.CurrentY = 20
    MainForm.Picture2.Print "10.0 kOm";
 
    icol = RGB(0, 0, 0): GoSub PUT_SW_1
Exit Sub

PUT_SW_1:
    MainForm.Picture2.Circle (ix0, iy0), ir1, icol
    MainForm.Picture2.Circle (ix0, iy0), ir2, icol
    MainForm.Picture2.Line (ix0, iy0)-(ix1, iy1), icol
    MainForm.Picture2.Line (ix1, iy1)-(ix3, iy3), icol
    MainForm.Picture2.Line (ix1, iy1)-(ix4, iy4), icol
    MainForm.Picture2.Line (ix3, iy3)-(ix4, iy4), icol
    Return

End Sub
'****************************************************************************
Sub GetRes(Dr As Double)
    '
    'Return the Resistance - DR (in Ohms), according to Switch - I
    '
    Static i1 As Integer, i2 As Integer
    Dim i As Integer

    If Dr = -1 Then i1 = 0: i2 = 0: Call GetSwitch(-1): Exit Sub

    Call GetSwitch(i)
    Select Case i
        Case 0:   Dr = 100
        Case 1:   Dr = 1000
        Case 2:   Dr = 10000
        Case Else: Dr = 1000000#
    End Select
    If i <> i1 Or i2 = 0 Then Call PutSwitch(i): i2 = 1
    i1 = i
End Sub
'****************************************************************************
Sub GetSwitch(iq As Integer)
    '
    'Get Position of Switch on the FBoard
    'I = 0 - Position 0
    '    1 -          1
    '    2 -          2
    '
    Static IZ As Integer, isw As Integer, iwork As Integer
 
    Dim IX As Integer

    If iq = -1 Then IZ = 0: isw = 0: iwork = 0

    iq = isw

    IX = InPort(IPORTB): IX = IX / 128

    If iwork = 0 Then
        iwork = 1
    Else
        If IX = IZ Then Exit Sub Else IX = InPort(IPORTB): IX = IX / 128
        Beep
    End If

    IZ = IX

    If IX = 1 Then iq = 0
    If IX = 2 Then iq = 1
    If IX = 0 Then iq = 2

    isw = iq
End Sub
'****************************************************************************
Function BIN$(IBIN As Integer)
    Dim i As Single
    Dim IBIN1 As Integer

    B$ = ""
    IBIN1 = IBIN
 
BIN10:
    i = IBIN1 / 2: B1$ = "0": If Int(i + 0.5) - Int(i) = 1 Then B1$ = "1"
    B$ = B1$ + B$
    i = Int(i)
    If i >= 1 Then IBIN1 = i: GoTo BIN10

    BIN$ = B$
End Function
'****************************************************************************
Sub GetPoint(Dput As Double, Dget As Double)
    Dim Iput As Integer
    Dim xIN As Integer, IN1 As Integer
    Dim iget As Integer, iget0 As Integer
    Dim iget1 As Integer, iget2 As Integer
    Dim i As Integer

    Iput = Dput * 100 + 512

    xIN = Val(CFG$(26))
    If xIN < 1 Then xIN = 1
    IN1 = xIN

    Call PutWord(Iput)

    iget = 9: iget0 = 0
    For i = 1 To xIN
        Call GetWord(iget1): iget2 = iget1
        If Abs(iget1 - iget0) > 8 Then iget1 = 0: IN1 = IN1 - 1
        iget = iget + iget1
        iget0 = iget1
    Next i
    If IN1 <> 0 Then iget = iget / IN1 Else iget = iget2

    Dget = (iget - 512) / 100
 End Sub
'****************************************************************************
Sub GetWord(iq As Integer)
    '
    'Get Word (Analog -> Digital) from FBoard
    '0 < IQ < 1023
    '

    Dim xIN As Integer
    Dim IX As Integer
    Dim i As Integer

    'init of register
    xIN = InPort(IPORTA)
    IX = xIN And 207
    Call OutPort(IPORTA, IX): Call MYDEL
    xIN = InPort(IPORTA)
    IX = xIN And 223
    IX = IX Or 16
    Call OutPort(IPORTA, IX): Call MYDEL

    iq = 0
    For i = 1 To 10
        xIN = InPort(IPORTB)
        xIN = (xIN And 32) / 32
        iq = iq + xIN * (2 ^ (10 - i))
        xIN = InPort(IPORTA)
        IX = IX And 239
        IX = IX Or 32
        Call OutPort(IPORTA, IX): Call MYDEL
        xIN = InPort(IPORTA)
        IX = xIN Or 48
        Call OutPort(IPORTA, IX): Call MYDEL
    Next i
End Sub
'****************************************************************************
Sub PutWord(iq As Integer)
    '
    'Put Word (Digital -> Analog) to FBoard
    '0 < IQ < 1023
    '
 
    Dim xIN As Integer
    Dim IX As Integer
    Dim i As Integer
    Dim IZ As Integer

    If iq < 0 Or iq > 1023 Then Exit Sub

    B$ = BIN$(iq): B$ = String$(10 - Len(B$), "0") + B$

    'init of register
    xIN = InPort(IPORTA)
    IX = xIN And 250
    Call OutPort(IPORTA, IX): Call MYDEL
    xIN = InPort(IPORTA)
    IX = xIN And 251
    IX = IX Or 1
    Call OutPort(IPORTA, IX): Call MYDEL

    For i = 1 To Len(B$)
        B1$ = Mid$(B$, i, 1): If B1$ = "1" Then IZ = 1 Else IZ = 0
  
        xIN = InPort(IPORTA)
        IX = xIN Or 4
        IX = IX And 254
        If IZ = 0 Then IX = IX And 253 Else IX = IX Or 6
        Call OutPort(IPORTA, IX): Call MYDEL
        xIN = InPort(IPORTA)
        IX = xIN Or 5
        If IZ = 0 Then IX = IX And 253 Else IX = IX Or 6
        Call OutPort(IPORTA, IX): Call MYDEL
    Next i
End Sub
'****************************************************************************
Sub MYDEL()
    Dim period As Long
    
    period = Val(CFG$(10))
  
    Call VBSleep(period)
End Sub
'****************************************************************************
Sub Light(i As Integer)
    '
    'Turn ON or OFF the light on the FBoard
    'I = 0 - OFF
    '    1 - ON
    '
    Dim IN1 As Integer, IX As Integer
 
    IN1 = InPort(IPORTC)
    If i = 0 Then IX = IN1 Or 2 Else IX = IN1 And 253
    
    Call OutPort(IPORTC, IX)
End Sub
'****************************************************************************
Public Sub SetPorts()
    IPORTA = Val("&H" + CFG$(25))
    IPORTB = IPORTA + 1
    IPORTC = IPORTA + 2
End Sub
'****************************************************************************
Public Sub FindDelay()
    Dim D As Double
    Dim D1 As Double
    Dim qmax As Integer
    Dim q As Integer
    Dim dummy As Integer
    Dim tb As Double
    Dim t As Double
            
    D1 = 100

FD1:
    tb = Timer
    For D = 1 To D1
        dummy = InPort(IPORTA)
    Next D
    If Abs(Timer - tb) < 0.2 Then
        D1 = D1 * 2
        GoTo FD1
    End If
        
    t = 0
    qmax = 5 'For averaging
    For q = 1 To qmax
        tb = Timer
        For D = 1 To D1
            dummy = InPort(IPORTA)
        Next D
        t = t + Abs(Timer - tb)
    Next q
    
    If t = 0 Then
        DDel = 10000000000#
    Else
        DDel = Int(D1 * qmax / t) / 1000000# 'microseconds
    End If
End Sub
'****************************************************************************
'delay = number of microseconds!
Public Sub VBSleep(delay As Long)
    Dim D As Double
    Dim DE As Double
    Dim dummy As Integer
    
    DE = DDel * delay
    
    For D = 1 To DE
        dummy = InPort(IPORTA)
    Next D
End Sub
'****************************************************************************
Function Convert1$(A As String)
    Dim X As Integer
    
    B$ = ""
    
    If A <> "" Then
        For X = 1 To Len(A)
            c$ = Mid$(A, X, 1)
            If c$ = "," Then c$ = "."
            B$ = B$ + c$
        Next X
    End If
    
    Convert1$ = B$
End Function
